from sys import stdin, argv
from math import log
from collections import defaultdict

freq = defaultdict(float)

total = 0
for row in open(argv[1],'r').readlines():
    freq[ row[:4] ] = float( row[5:] )
    total += float( row[5:] )

for t in freq: freq[t] /= total

raw_text = stdin.read().lower()
text = ''
for x in raw_text:
    if x.isalpha(): text += x
    # alternativa ak mame tetragramy aj s medzerami:
    # if x.isalpha() or x==' ': text += x

surprise = 0.
for i in range( len(text)-3 ): surprise -= log( max( freq[ text[i:i+4] ], 1e-8 ) ) # max(x,1e-8) je tam kvoli stvoriciam ktore maju v nasej db freq=0
print('{:.4f}'.format(surprise))
